using System;

namespace Smdn.Protocols.Imap4.Protocol {
  // ResponseTypes:
  //   ImapProtocolResponse(abstract base)
  //     => handles '7. Server Responses'
  //     ImapStatusResponse
  //       => handles '7.1. Server Responses - Status Responses'
  //     ImapDataResponse
  //       => handles '7.2. Server Responses - Server and Mailbox Status'
  //                  '7.3. Server Responses - Mailbox Size'
  //                  '7.4. Server Responses - Message Status'
  //     ImapCommandContinuationRequest
  //       => handles '7.5. Server Responses - Command Continuation Request'

  public class ImapCommandContinuationRequest : ImapProtocolResponse {
    public string Text {
      get { return text; }
    }

    public ImapCommandContinuationRequest(string text, string response)
      : base(response)
    {
      this.text = text;
    }

    public override string ToString()
    {
      return string.Format("{{Text={0}}}", text);
    }

    private string text;
  }
}