using System;

namespace Smdn.Protocols.Imap4.Protocol {
  // Layers:
  //   Client.ImapClient
  //   Client.ImapClientAgent
  //   Session.ImapSessionAgent
  //   Session.ImapSession
  //   Transaction.ImapTransactionAgent
  //   Transaction.ImapTransaction/Transaction.ImapRequest/Transaction.ImapResponse
  // * Protocol.ImapConnection/Protocol.ImapProtocolCommand/Protocol.ImapProtocolResponse
  //   (IMAP4)

  // ResponseTypes:
  //   ImapProtocolResponse(abstract base)
  //     => handles '7. Server Responses'
  //     ImapStatusResponse
  //       => handles '7.1. Server Responses - Status Responses'
  //     ImapDataResponse
  //       => handles '7.2. Server Responses - Server and Mailbox Status'
  //                  '7.3. Server Responses - Mailbox Size'
  //                  '7.4. Server Responses - Message Status'
  //     ImapCommandContinuationRequest
  //       => handles '7.5. Server Responses - Command Continuation Request'

  public abstract class ImapProtocolResponse {
    public string Response {
      get { return response; }
    }

    protected ImapProtocolResponse(string response)
    {
      if (response == null)
        throw new ArgumentNullException("response");

      this.response = response;
    }

    private string response = string.Empty;
  }
}