using System;

namespace Smdn.Protocols.Pop3 {
  [Flags()]
  public enum PopKnownCapabilities : int
  {
    None              = 0x00000000,

    Apop              = 0x00000001, // RFC 1939 Post Office Protocol - Version 3

    AuthKerberosV4    = 0x00000002, // RFC 1734 POP3 AUTHentication command
    AuthCramMd5       = 0x00000004, // RFC 2195 IMAP/POP AUTHorize Extension for Simple Challenge/Response
    AuthPlain         = 0x00000008, // ?
    AuthLogin         = 0x00000010, // ?

    // RFC 2449 POP3 Extension Mechanism
    Capabilities      = 0x00010000, // 5.  The CAPA Command
    Top               = 0x00020000, // 6.1.  TOP capability
    User              = 0x00040000, // 6.2.  USER capability
    RespCodes         = 0x00080000, // 6.4.  RESP-CODES capability
    LoginDelay        = 0x00100000, // 6.5.  LOGIN-DELAY capability
    Pipelining        = 0x00200000, // 6.6.  PIPELINING capability
    Expire            = 0x00400000, // 6.7.  EXPIRE capability
    Uidl              = 0x00800000, // 6.8.  UIDL capability
    Implementation    = 0x01000000, // 6.9.  IMPLEMENTATION capability

    Stls              = 0x02000000, // ?
  }
}
